<template>
  <div class="order-draft-sidebar">
    <template v-if="!tariffError">
      <template v-if="orderType === 'TMS'">
        <template v-if="!tariffEmpty">
          <div class="order-draft-sidebar__title">
            <i class="icon checked"></i>
            Для вашего маршрута найдены тарифы<br />из договора
          </div>
          <tariff
            v-for="(item, index) in openedTariffs"
            :key="item.tariffUuid"
            :tariff="item"
            :index="index"
            :shouldBeChecked="tariff === item.tariffUuid"
            @tariffChanged="onTariffChanged"
          />
          <span
            class="expand-tariff"
            v-if="hiddenTariffs.length && !tariffsExpanded"
            @click="tariffsExpanded = true"
          >
            Показать ещё {{ this.hiddenTariffs.length }}
            <i class="icon chevron-down"></i>
          </span>
          <expand-transition>
            <div v-if="tariffsExpanded">
              <tariff
                v-for="(item, index) in hiddenTariffs"
                :key="item.tariffUuid"
                :tariff="item"
                :shouldBeChecked="tariff === item.tariffUuid"
                :index="index"
                @tariffChanged="onTariffChanged"
              />
              <span
                class="expand-tariff"
                v-if="tariffsExpanded"
                @click="tariffsExpanded = false"
              >
                Свернуть
                <i class="icon chevron-up"></i>
              </span>
            </div>
          </expand-transition>
        </template>
        <template v-if="priceForOnline.total_price">
          <online-price :priceForOnline="priceForOnline" :shouldBeChecked="tariff === 'onlinePrice'" @tariffChanged="onTariffChanged" />
          <div class="fetched-contracts" v-if="fetchedContracts.length && tariff === 'onlinePrice'">
            <contracts
              ref="onlinePriceContracts"
              :fetchedContracts="fetchedContracts"
              @contractChanged="onContractChanged"
            />
          </div>
        </template>
        <div class="order-draft-sidebar__manual-tariff">
          <manual-tariff
            :shouldBeChecked="tariff === 'tariffByHand'"
            :fetchedContracts="fetchedContracts"
            :manualTariffVat="manualTariffVat"
            @tariffChanged="onTariffChanged"
            @contractChanged="$emit('contractChanged', $event)"
            @updateTariffByHand ="$emit('updateTariffByHand', $event)"
          />
        </div>
      </template>

      <template v-if="orderType === 'ANY'">
        <div class="order-draft-sidebar__title">
          <i class="icon info"></i>
          Для вашего маршрута доступна онлайн-цена
        </div>
        <online-price-preselect :priceForOnline="priceForOnline" />
      </template>

      <template v-if="orderType === 'DIRECT'">
        <div class="order-draft-sidebar__title">
          <i class="icon checked"></i>
          {{ directOrderTitle }}
        </div>
        <template v-if="!tariffEmpty">
          <tariff
            v-for="(item, index) in openedTariffs"
            :key="item.tariffUuid"
            :tariff="item"
            :index="index"
            :shouldBeChecked="tariff === item.tariffUuid"
            @tariffChanged="onTariffChanged"
          />
          <span
            class="expand-tariff"
            v-if="hiddenTariffs.length && !tariffsExpanded"
            @click="tariffsExpanded = true"
          >
            Показать ещё {{ this.hiddenTariffs.length }}
            <i class="icon chevron-down"></i>
          </span>
          <expand-transition>
            <div v-if="tariffsExpanded">
              <tariff
                v-for="(item, index) in hiddenTariffs"
                :key="item.tariffUuid"
                :tariff="item"
                :shouldBeChecked="tariff === item.tariffUuid"
                :index="index"
                @tariffChanged="onTariffChanged"
              />
              <span
                class="expand-tariff"
                v-if="tariffsExpanded"
                @click="tariffsExpanded = false"
              >
                Свернуть
                <i class="icon chevron-up"></i>
              </span>
            </div>
          </expand-transition>
        </template>
        <template v-if="priceForOnline.total_price">
          <online-price
            :tariff="tariff"
            :shouldBeChecked="tariff === 'onlinePrice'"
            :priceForOnline="priceForOnline"
            @tariffChanged="onTariffChanged"
          />
          <div class="fetched-contracts" v-if="fetchedContracts.length">
            <contracts
              ref="onlinePriceContracts"
              :fetchedContracts="fetchedContracts"
              @contractChanged="onContractChanged"
            />
          </div>
        </template>
      </template>

      <template v-if="(orderType === 'STANDARD' && transportationWay === 'FTL')">
        <div class="order-draft-sidebar__title">
          <i class="icon checked"></i>
          {{ standardOrderTitle }}
        </div>
        <template v-if="!tariffEmpty">
          <tariff
            v-for="(item, index) in openedTariffs"
            :key="item.tariffUuid"
            :tariff="item"
            :index="index"
            :shouldBeChecked="tariff === item.tariffUuid"
            @tariffChanged="onTariffChanged"
          />
          <span
            class="expand-tariff"
            v-if="hiddenTariffs.length && !tariffsExpanded"
            @click="tariffsExpanded = true"
          >
            Показать ещё {{ this.hiddenTariffs.length }}
            <i class="icon chevron-down"></i>
          </span>
          <expand-transition>
            <div v-if="tariffsExpanded">
              <tariff
                v-for="(item, index) in hiddenTariffs"
                :key="item.tariffUuid"
                :tariff="item"
                :shouldBeChecked="tariff === item.tariffUuid"
                :index="index"
                @tariffChanged="onTariffChanged"
              />
              <span
                class="expand-tariff"
                v-if="tariffsExpanded"
                @click="tariffsExpanded = false"
              >
                Свернуть
                <i class="icon chevron-up"></i>
              </span>
            </div>
          </expand-transition>
          <ob-radio
            label="Онлайн-цена"
            valueInput="onlinePrice"
            name="tariff"
            :data-qa="'online-price'"
            v-model="tariff"
            @change="$emit('tariffChanged', tariff)"
          />
          <div class="fetched-contracts" v-if="fetchedContracts.length">
            <contracts
              ref="onlinePriceContracts"
              :fetchedContracts="fetchedContracts"
              @contractChanged="$emit('contractChanged', $event)"
            />
          </div>
        </template>
        <template v-if="tariffEmpty">
          <ob-radio
            label="Онлайн-цена"
            valueInput="onlinePrice"
            name="tariff"
            :data-qa="'online-price'"
            v-model="tariff"
            @change="$emit('tariffChanged', tariff)"
          />
          <div class="fetched-contracts" v-if="fetchedContracts.length">
            <contracts
              ref="onlinePriceContracts"
              :fetchedContracts="fetchedContracts"
              @contractChanged="$emit('contractChanged', $event)"
            />
          </div>
        </template>
      </template>

      <template
        v-if="
          (orderType === 'STANDARD' && transportationWay === 'RAIL') ||
          (orderType === 'STANDARD' && transportationWay === 'CONTAINER')
        "
      >
        <div class="order-draft-sidebar__title">
          <i class="icon checked"></i>
          Для вашего заказа доступна онлайн-цена
        </div>
        <div class="fetched-contracts" v-if="fetchedContracts.length">
          <contracts
            ref="onlinePriceContracts"
            :fetchedContracts="fetchedContracts"
            @contractChanged="$emit('contractChanged', $event)"
          />
        </div>
      </template>
    </template>
    <template v-else>
      <div class="order-draft-sidebar__error-title">
        <i class="icon info"></i>
        Ошибка при поиске тарифа
      </div>
      <div class="order-draft-sidebar__error">
        <p>Что-то пошло не так. Попробуйте ещё раз.</p>
        <p>
          Если ошибка будет повторяться, свяжитесь со службой поддержки
          платформы {{ $options.contacts[platform].title }} по телефону
          <a :href="`tel:${$options.contacts[platform].linkphone}`">{{
            $options.contacts[platform].phone
          }}</a>
          или почте
          <a :href="`mailto:${$options.contacts[platform].email}`">{{
            $options.contacts[platform].email
          }}</a>
        </p>
      </div>
      <div class="order-draft-sidebar__action">
        <ob-button
          label="Попробовать ещё раз"
          :isFullWidth="true"
          data-qa="btnTryAgain"
          @click="$emit('retakeTariff')"
        />
      </div>
    </template>
  </div>
</template>

<script>
import { contacts } from "@/resources/contacts";
import { formatNumber } from "common-components/src/helpers/common";
import obRadio from "common-components/src/obComponents/obRadio";
import obButton from "common-components/src/obComponents/obButton";
// import obCheckbox from "common-components/src/obComponents/obCheckbox";
// import obInput from "common-components/src/obComponents/obInput";
import expandTransition from "common-components/src/obComponents/obExpandTransition";
// import obTooltip from "common-components/src/obComponents/obTooltip";
import tariff from "./draftTariff";
import onlinePrice from "./draftOnlinePrice";
import onlinePricePreselect from "./draftOnlinePricePreselect";
import manualTariff from './draftManualTariff';
import contracts from "./fetchedContracts";

export default {
  name: "clientSidearNew",

  props: {
    orderType: {
      type: String,
      required: true,
    },

    actualTariff: {
      type: String
    },

    tariffs: {
      type: Array,
      default: () => [],
    },

    tariffError: {
      type: Boolean,
      default: () => false,
    },

    tariffEmpty: {
      type: Boolean,
      default: () => false,
    },

    priceForOnline: {
      type: Object,
      required: true,
    },

    fetchedContracts: {
      type: Array,
      default: () => [],
    },

    manualTariffVat: {
      type: [String, Number],
      default: 0,
    },

    transportationWay: {
      type: String,
      required: true,
    },
  },

  components: {
    obRadio,
    obButton,
    expandTransition,
    // obTooltip,
    tariff,
    contracts,
    onlinePrice,
    onlinePricePreselect,
    manualTariff,
    // obCheckbox,
    // obInput,
  },

  contacts,

  data() {
    return {
      tariff: null,
      tariffsExpanded: false,
      includeVat: false,
      tariffByHandValue: ""
    };
  },

  watch: {
    actualTariff: {
      handler: function(newVal) {
        if (newVal) {
          this.tariff = newVal;
        }
      },
      immediate: true
    },
  },

  computed: {
    directOrderTitle() {
      if (!this.tariffEmpty && this.priceForOnline.total_price) {
        return "Для вашего маршрута доступны тарифы из договора и онлайн-цена ";
      } else if (!this.tariffEmpty && !this.priceForOnline.total_price) {
        return "Для вашего маршрута доступны тарифы из договора";
      } else if (this.tariffEmpty && this.priceForOnline.total_price) {
        return "Для вашего маршрута доступна онлайн-цена";
      }
      return "";
    },

    standardOrderTitle() {
      if (!this.tariffEmpty) {
        return "Для вашего маршрута доступны тарифы из договора и онлайн-цена ";
      } else if (this.tariffEmpty) {
        return "Для вашего маршрута доступна онлайн-цена";
      }
      return "";
    },

    finalTariffByHand() {
      if (this.tariffByHandValue.length) {
        const vat = this.includeVat
          ? this.tariffByHandValue / 100 -
            (this.tariffByHandValue / 100) *
              (100 / (100 + this.manualTariffVat)) +
            ""
          : 0;
        return this.tariffByHandValue - (vat * 100).toFixed() + "";
      }
      return '';
    },

    manualTariffTax() {
      return this.includeVat
        ? this.tariffByHandValue / 100 -
            (this.tariffByHandValue / 100) *
              (100 / (100 + this.manualTariffVat))
        : ((this.tariffByHandValue / 100) * this.manualTariffVat) / 100;
    },

    openedTariffs() {
      if (this.tariffs.length > 3) {
        const res = [...this.tariffs];
        return res.splice(0, 3);
      }
      return this.tariffs;
    },

    hiddenTariffs() {
      if (this.tariffs.length <= 3) {
        return [];
      }

      const res = [...this.tariffs];
      return res.splice(3);
    },

    platform() {
      return window.OBOZ_CONFIG.OBOZ_API_HOST.includes("oboz")
        ? "oboz"
        : "gruzi";
    },
  },

  methods: {
    formatNumber,

    onHandTariffFocus() {
      this.tariff = "tariffByHand";
      // this.$emit("tariffChanged", "tariffByHand");
    },

    onTariffChanged($event) {
      this.tariff = $event;
      if (this.$refs.onlinePriceContracts) {
        this.$refs.onlinePriceContracts.reset();
      }
      this.$emit("tariffChanged", $event);
    },

    onContractChanged($event) {
      this.tariff = "onlinePrice";
      this.$emit("contractChanged", $event);
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
@import "~common-components/src/static/css/variables";

.fetched-contracts {
  padding-left: 24px;
  padding-top: 17px;
}

.order-draft-sidebar__title,
.order-draft-sidebar__error-title {
  margin-top: 5px;
  margin-bottom: 15px;
  display: flex;
  align-items: center;
  font-size: 16px;
  line-height: 1.2;
  letter-spacing: 0.4px;
  font-weight: 700;
  color: #0070a6;

  .icon {
    margin-right: 16px;
    font-size: 24px;
  }
}

.order-draft-sidebar__error-title {
  color: $color-error;
}

.order-draft-sidebar__error {
  p {
    margin-bottom: 10px;
  }

  a {
    text-decoration: none;
    color: $cobalt-blue;
  }
}

.order-draft-sidebar__action {
  margin-top: 20px;
}

.order-draft-sidebar__manual-tariff {
  margin-top: 20px;
}
</style>